' 
' SIDcog TrainSound 
' 

CON _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000    
    freqAdjust  = 1.33                       ' Adjust the relative frequency of both 1 and 2 
    freq1       = trunc(7000.0*freqAdjust)   ' Whistle frecuency 1                              
    freq2       = trunc(5750.0*freqAdjust)   ' Whistle frecuency 2
    
var
    long volume

OBJ
  SID  : "SIDCog"
  mouse: "mouse"
  kb   : "keyboard"
  term : "tv_terminal"


PUB Main | i, whistle, frame, finetune, tmp, updaterate, junk, whistle_decay,timbre, timer

  term.start(12)
  kb.start(26, 27)
  mouse.start(24, 25)
  SID.start(10,11)                        'Start the emulated SID and output sound on pin 10 and 11 

  'defaults
  volume := 5                             'sound volume
  updateRate  := 130                      'Tuff tuff speed
  timbre := 13000
  timer := 0
  SID.setVolume(volume)                   
  SID.setCutoff(150)

  
  repeat
    waitcnt(cnt+(clkfreq/updateRate))
    frame++

    'mouse inputs
    whistle := mouse.buttons & %11             'Left or right mouse button for whistle   
    tmp := updateRate + mouse.delta_z*3
    if mouse.buttons & %1                      'hold down left mouse & scroll to adjust volume
      if mouse.delta_z>0
        volume++
      elseif mouse.delta_z<0
        volume--
    else       
      updateRate := 4 #> tmp <# 250            'scroll wheel for controlling train speed

    'keyboard inputs
    tmp := kb.key
    case tmp
       194 : volume++              'up arrow for more volume
       195 : volume--              'dn arrow for less volume
       32  : whistle:=1
'       116 : timbre+=1000    'T to increase chuff timbre
'       121 : timbre-=1000    'Y to decrease chuff timbre
    volume := 0 #> volume <# 12 
'    timbre := 5000 #> timbre <# 15000

    'shut train sound off after ~3 minutes inactivity
    timer += (10000/updaterate)
    if timer >  10000*60*3
      SID.setVolume(0)
      repeat until mouse.buttons & %11        'press mouse button to wake up
      SID.setVolume(volume)
    if whistle or tmp
      timer := 0 

    'Tuff tuff sound
    if updaterate>5
      if (frame&15)==7 and not whistle
        SID.play(0,5000+((?i)&511),SID#NOISE,5,5,5,9)
    if (frame&15) == 12 and not whistle
      SID.noteOff(0)
       
    'Whistle sound
    if whistle                                           'whistle attack
      SID.setVolume(volume+1)
      finetune:=(finetune+20)<#1000
      SID.setResonance(15)
      SID.setFilterMask(true,true,true) 
      SID.setFilterType(false,true,true)
      SID.play(0,22_000,SID#NOISE,0,0,3,3)
      SID.play(1,freq1+finetune,SID#TRIANGLE,1,1,4,3) 
      SID.play(2,freq2+finetune,SID#TRIANGLE,1,1,6,3) 
      whistle_decay:=finetune
    elseif whistle_decay                                 ' whistle decay
      finetune:= 0 #> (finetune-40)
      SID.setResonance(15)
      SID.setFilterMask(true,true,true) 
      SID.setFilterType(false,true,true)
      SID.play(0,22_000,SID#NOISE,0,0,3,3)
      SID.play(1,freq1+finetune,SID#TRIANGLE,1,1,4,3) 
      SID.play(2,freq2+finetune,SID#TRIANGLE,1,1,6,3) 
      whistle_decay:=finetune                             'whistle off
    else
      SID.setVolume(volume)
      finetune:=0
      SID.setResonance(10)
      SID.setFilterMask(true,false,false)
      SID.setFilterType(true,true,false)
      SID.noteOff(1)
      SID.noteOff(2)

    'tv display
    if (frame&15)==7 and updaterate>5
      if whistle
        term.str(string("   WHISTLE",13))
      else
        if junk//2==0
          term.str(string("CHUFF...",13))
        else
          term.str(string("     ...CHUFF",13))
        junk++
   
        